# Copyright start
# Copyright (C) 2008 - 2021 Fortinet Inc.
# All rights reserved.
# FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
# Copyright end

get_hostname_extn_host(){
    local hostname_extn=$($fdc_extn_settings --get-hostname)
    echo "$hostname_extn"
}

get_ip_extn_host(){
    local ip_extn=$($fdc_extn_settings --get-ip)
    echo "$ip_extn"
}

source_docker_config(){
    fsr_docker_config="/opt/cyops/configs/scripts/docker/config"
    source $fsr_docker_config
}

is_docker(){
    if [ ! -f "$fdc_flag_fsr_in_docker" ]; then
        # 1 means false
        return 1
    fi
    # 0 means true
    return 0
} 

is_fmg(){
    # 1 means false
    local flag_is_fmg=1

    if [ ! -f "$FILE_FSR_RUNNING_IN_FMG" ]; then
        return $flag_is_fmg
    fi

    local cmd="$fdc_extn_settings --check-if-fmg"
    if $cmd &>/dev/null; then
        # 0 means true
        flag_is_fmg=0
    fi
    return $flag_is_fmg
}

is_faz(){
    # 1 means false
    local flag_is_faz=1

    if [ ! -f "$FILE_FSR_RUNNING_IN_FAZ" ]; then
        return $flag_is_faz
    fi

    local cmd="$fdc_extn_settings --check-if-faz"
    if $cmd &>/dev/null; then
        # 0 means true
        flag_is_faz=0
    fi
    return $flag_is_faz
}

initialize_global_variables(){
    GLOBAL_VAR_EXTN_HOSTNAME=$(get_hostname_extn_host)
    GLOBAL_VAR_EXTN_IP=$(get_ip_extn_host)
}

notify_ui_fortisoar_state(){
    local payload=$1
    echo "Notifying UI with payload as $payload"
    $fdc_state_updater --app-name extension \
                       --state-file $fdc_file_extn_fsr_provision \
                       --payload "$payload"

    chmod 644 $fdc_file_extn_fsr_provision
    chown nginx:nginx $fdc_file_extn_fsr_provision
}

add_self_entry_in_etc_hosts(){
    local entry="$GLOBAL_VAR_EXTN_IP $GLOBAL_VAR_EXTN_HOSTNAME"
    local file_etc_hosts="/etc/hosts"
    echo "Adding entry in $file_etc_hosts [$entry]"
    echo "$entry" >> $file_etc_hosts
}

is_extension(){
    local check_type=$1

    if [ "X$check_type" = "Xstrict_check" ]; then
        if is_fmg || is_faz; then
            # 0 means true
            return 0
        fi
        # 1 means false
        return 1
    fi

    # Here comes, means user requested soft checking which is file based only.

    # 1 means false
    local flag_is_extn=1

    for flag_file in $LIST_FLAG_FILES
    do
        if [ -f "$flag_file" ]; then
            # 0 means true
            flag_is_extn=0
            break
        fi
    done

    return $flag_is_extn
}



########
# Main/main/MAIN starts here
#####

#################
# How to use this?
# fsr_docker_utils_sh="/opt/cyops/configs/scripts/docker/utils.sh"
# source $fsr_docker_utils_sh
#
# This is currently getting used in
#
# /opt/cyops/configs/scripts/docker/cron-config-handler.sh
# /opt/cyops/configs/scripts/docker/boot-config.sh
# /opt/cyops/configs/scripts/docker/shutdown-config.sh
# In csadm framework, /opt/cyops/adm/csadm
# 1. /opt/cyops/adm/subcmd/mq-common : is_docker, get_hostname_extn_host
# 2. /opt/cyops/adm/subcmd/db        : is_docker, is_extension
#
#
##########

source_docker_config
